//
//	Xanthus
//	Copyright (c) 1992, 1993, 1994 Xanthus International AB.  
//	All rights reserved. 
//

//
// OpenWrite supports the following application delegate
// methods.

// These messages are sent when the OpenWrite application delegate receives
// the messages from the appkit.

@protocol OpenWrite_AppDelegate_OAE_Protocol

// 
// Basic App Delegate Protocol
//

- appWillInit:sender;
	
	// Returning non-nil tells app to terminate


- appDidInit:sender;
	
	// Returning non-nil tells app to terminate


- app:sender 
	powerOffIn:(int)ms 
	andSave:(int)andSave;
- appWillUpdate:sender;
- appDidUpdate:sender;
- appDidUnhide:sender;
- appDidResignActive:sender;
- appDidHide:sender;
- appDidBecomeActive:sender;
- appWillTerminate:sender;


//
// Open Doc Protocol
//

- appWillOpenDocument: (char *)path;

	// Returning non-nil tells app not to open document
	// Alter 'path' to open other document
	
- appWillOpenDocumentReadOnly: (char *)path;

	// Returning non-nil tells app not to open document
	// Alter 'path' to open other document
	
- appWillOpenCopyOfDocument: (char *)path;

	// Returning non-nil tells app not to open document
	// Alter 'path' to open other document


@end