//
//	Xanthus
//	Copyright (c) 1992, 1993, 1994 Xanthus International AB.  
//	All rights reserved. 
//

//
// This is the basic OAE protocol for documents supported by OpenWrite
//

@protocol OpenWrite_Document_OAE_Protocol

- documentWasCreated:aDoc;

- documentWasOpened:aDoc;

//
//
//

- document:aDoc 
	willPresentSavePanel:(char *)path;

	// Change 'path' to set save path
	// Return non-nil to use 'path' instead of
	// presenting the save panel to the user
	
	// Return path[0] = NULL to abort save

- document:aDoc willSaveAs:(char *)path;
	
	// Return non-nil to abort save
	// Change 'path' to alter target path


- document:aDoc willSaveTo:(char *)path;
	
	// Return non-nil to abort save
	// Change 'path' to alter target path

- documentWillSave:aDoc;
	
	// Return non-nil to abort save

- documentDidSave:aDoc;

- document:aDoc didSaveAs:(const char *)apath;

- document:aDoc didSaveTo:(const char *)apath;

- documentIsEdited:aDoc;


//
// Print Protcol
//

- documentWillPrint:aDoc;
	
	// Returning non-nil tells app not to print


- documentDidPrint:aDoc;

- document: aDoc didPrintPage:(int)pageIndex;

	// Add PostScript to current page
	
@end



//
// This protocol is understood by document objects
// provides as arguments to the document oae protocol above;

@protocol OpenWrite_Document_OAE_Sender_Protocol

- (const char *)fileExtension;
	
	// Returns the file extension (i.e. "xow")
	
	
- getPrintInfo;	

	// Return appkit PrintInto object used by document
	
@end



