//
//	Xanthus
//	Copyright (c) 1992, 1993, 1994 Xanthus International AB.  
//	All rights reserved. 
//

#import "DocumentPrintDemo.h"


@implementation DocumentPrintDemo

- (const char *)timeAsString: (time_t)time;
{
	static char buf[128];
	const char *format;
	struct tm *tp;
	
 	tp = localtime(&time);

   	format = NXGetDefaultValue([NXApp appName], "NXDateAndTime");
   	if(format == NULL) format = "%b %d %y %H:%M";

	strftime(buf, 127, format, tp);
	
	return buf;
}

- document:aDoc didPrintPage:(int)pageIndex;
{
	float psize = 10;
	id font = nil;
	char buf[512];
	
	font = [Font newFont: "Helvetica" 
			size: psize
			matrix: NX_IDENTITYMATRIX];

	sprintf(buf, "Page %d. Printed by %s: %s.", 
			pageIndex,				
			NXUserName(),
			[self timeAsString: time(0)]
		);
	
	PSgsave();
	
	    PSsetgray(NX_DKGRAY);
	    [font set];
	    
	    PSmoveto(10, 10);	// hack
    
	    PSshow(buf);

	PSgrestore();
	
	return self;
}

@end

