//
//	Copyright (c) 1995 Bjorn Backlund.  
//	All rights reserved. 
//

#import "app.h"


@implementation Cosmo_App (Opening)

- (const char *)promptForFileName;
{
	id openPanel;
	int ok;
	
    // Prompt the user for a file name,
    // use the NEXTSTEP builtin OpenPanel

    // Note, this version allows opening only one single file
    // at a time
    
    // Get the OpenPanel object
	
	openPanel = [OpenPanel new];
	
    // Set the file extension we want our filenames to end with
	
	[openPanel setRequiredFileType: "cosmo"];
	
    // Open panel and let user enter/select a file name
	
	ok = [openPanel runModal];
	
    // Check if user cancelled the operation
	
	if(ok != NX_OKTAG) return NULL;
	
    // Return the selected file name
	
	return [openPanel filename];
}

- openDocument:sender;
{
	const char *file;
	id aDoc;
	
    // Prompt user for a file to open
	
	file = [self promptForFileName];
	
	if(file == NULL) return nil;
	
    // Create a new document and let it read data from the file
	
	aDoc = [[Cosmo_Doc allocFromZone:[self zone]] init];
	[aDoc openDocumentFrom: file];
	
    // add document to list of documents
    
    	[theDocuments addObject: aDoc];
	
    // Get window of document and let is display
    
    	[[aDoc theWindow] display];
    
   // Get window of document and open it
    
    	[[aDoc theWindow] makeKeyAndOrderFront:nil];
    
	return aDoc;
}

@end


