//
//	Copyright (c) 1995 Bjorn Backlund.  
//	All rights reserved. 
//

#import "app.h"


@implementation Cosmo_Doc (Initialization)

- init;
{
    // initialize the polylines variable to an empty list
	
	thePolylines = [[List allocFromZone:[self zone]] init];	
	
    // Load interface
    
	[self loadInterfaceFile];	
	
	return self;
}

- loadInterfaceFile;
{
	id r;
	NXRect aFrame = {0,0,0,0};
	
    // load the InterfaceBuilder file for a Cosmo Document
	
	r = [NXApp loadNibSection:"Cosmo_Doc.nib" 
			owner:self 
			withNames:NO];
	
	if(r == nil) {
		
		NXLogError("ERROR: Could not load nib "
				"file Cosmo_Doc.nib.");
		
		return nil;
			
	}
	
    // At this stage, theWindow has been 
    // set to the window object in the interface file

    // Make myself the delegate of the window
    
	[theWindow setDelegate:self];
    
   // Calc the size of the view = approx. the size of a Letter sheet
	
	NX_WIDTH(&aFrame) = 8 * 72;
	NX_HEIGHT(&aFrame) = 11 * 72;
	
    // Create a Cosmo_ScrollView and make it the content view of the
    // window loaded from the interface file
    
  	theScrollView = [[Cosmo_ScrollView allocFromZone:[self zone]] 
				initFrame: &aFrame];
  
	[[theWindow setContentView: theScrollView] free];

    // Create a Cosmo_View and set it as the document view of the
    // scroll view
	
	theView = [[Cosmo_View allocFromZone:[self zone]] 
				initFrame: &aFrame];
	
	[[theScrollView setDocView: theView] free];
	
    // Tell the view who it belongs to
    
	[theView setTheDocument:self];
	
    // Make the Cosmo view the "first responder" of the window
    
	[theWindow makeFirstResponder:theView];
	
    // Tell window to draw itself the first time
    
    	[theWindow display];
	
	return self;
}

@end


