//
//	Copyright (c) 1995 Bjorn Backlund.  
//	All rights reserved. 
//

#import "app.h"


@implementation Cosmo_Doc (Opening)

- openDocumentFrom: (const char *)file;
{
	NXTypedStream *s;
	
    // Open a stream on the file
	
	s = NXOpenTypedStreamForFile(file, NX_READONLY);
	
	if(s == NULL) {
		
		NXLogError("ERROR: Could not open stream for %s.", file);
		return nil;
	}
	
    // Read data from the stream
    
    	[self readDataFrom:s];

    // Close the stream
    
    	if(s != NULL) NXCloseTypedStream(s);
	
    // NOTE: the NXCloseTypedStream might raise an exception
    // but we don't care for simplitcily
	
	return self;
}

- readDataFrom: (NXTypedStream *)s;
{
	
    // Free any previously created polylines
    
    	[[thePolylines freeObjects] free];
    	
    // Read the polylines from the stream
    
    	thePolylines = NXReadObject(s);

	return self;
}


@end


