//
//	Copyright (c) 1995 Bjorn Backlund.  
//	All rights reserved. 
//

#import "app.h"


@implementation Cosmo_Polyline (Drawing)

- buildPolylinePath;	// build a PostScript path
{
	int i, size;
	id aPoint;
	
    // obtain the number of points 
    
	size = [self count];
	
    // get the first point
    
	aPoint = [self objectAt: 0];
	
    // tell it to initialize a new PostScript path
	
	[aPoint initializePath];
		
    // loop over the rest if the points, adding line segments
	
	for(i=1; i<size; i++) {

		aPoint = [self objectAt: i];
	
		[aPoint addLineSegment];

	}
    
	return self;
}

- drawInView:aView;	// Draw polyline within aView
{
    // setup PostScript graphics state
    
    	PSsetlinewidth(1);		// the line width
	PSsetgray(NX_BLACK);		// paint black
    
    // build a PostScript path
    
    	[self buildPolylinePath];
	
    // draw the polyline segment built in the PostScript server
	
	PSstroke();
	
	return self;
}

- drawAsSelectedInView:aView;	
{
	int i, size;
	id aPoint;
	
    // obtain the number of points 
    
	size = [self count];
	
    // loop over the points, let each of the display a rectangle
	
	for(i=0; i<size; i++) {

		aPoint = [self objectAt: i];
	
		[aPoint drawAsSelectedInView:aView];

	}
    
	return self;
}


@end


