//
//	Copyright (c) 1995 Bjorn Backlund.  
//	All rights reserved. 
//


#import "app.h"

@implementation Cosmo_ScrollViewButton

- initFrame: (const NXRect *)rect;
{
	[super initFrame: rect];
	
    // Send the message selected: to the button itself 
    // when selected
	
	[self setAction: @selector(selected:)];
	[self setTarget: self];
	
    // Define the appearance
    
	[self setBordered:NO];
	[self setIconPosition:NX_ICONONLY];
	[self setImage: 
		[NXImage findImageNamed: "OOE_ScrollerButton"]];
	[self setAltImage: 
		[NXImage findImageNamed: "OOE_ScrollerButtonH"]];
	[self setType: NX_MOMENTARYCHANGE];
	[self setFrame: rect];

    // Disable the button, the document will enable it
    // when it becomes an OOE document
	
	[self setEnabled:NO];
	
	return self;
}

- selected:sender;
{
	id document = [window delegate];
	int isAltPressed;
	
    // Determine if the alternate button is pressed
    
 	isAltPressed = ([NXApp currentEvent]->flags & 
				NX_ALTERNATEMASK);

    // If the document is changed, save it
    
	if([window isDocEdited])
		[document saveDocument:nil];
 	else [document orderClientDocumentFront:nil];
	
    // If not the alternate button is pressed, close the document
    // by closing the window
    
	if(!isAltPressed && ![window isDocEdited])
		[window performClose:nil];
		
	return self;
}

- setEnabled: (BOOL)flag;
{
    // Use different images depening on the state
    
	if(flag) 
		[self setImage: 
			[NXImage findImageNamed: "OOE_ScrollerButtonE"]];
	else [self setImage: 
			[NXImage findImageNamed: "OOE_ScrollerButtonD"]];
	
    // Call inherited code
	
	return [super setEnabled:flag];
}


@end


