//
//	Copyright (c) 1995 Bjorn Backlund.  
//	All rights reserved. 
//

#import "app.h"


@implementation Cosmo_View (Drawing)

- drawSelf:(const NXRect *)r : (int)count;	
{
	id polylines;
	int size, i;
	id aPolyline;
	
    // paint the background white
	
	PSsetgray(NX_WHITE);
	NXRectFill(&bounds);
	
    // obtain the list of polylines from the 
    // document the view belogs to
	
	polylines = [theDocument thePolylines];
	
    // obtain the size of the list
	
	size = [polylines count];
	
    // loop over the polyline objects, 
    // sending each of them the message 
    // drawInView: with the view as the argument
	
	for(i=0; i<size; i++) {

		aPolyline = [polylines objectAt: i];
		[aPolyline drawInView:self];

	}
	
    // let the selected polyline draw itself again, 
    // but only if we are drawing to the screen (i.e. not printing)

	if(NXDrawingStatus == NX_DRAWING)
		[theSelectedPolyline drawAsSelectedInView:self];
	
	return self;
}

@end


