//
//	Xanthus
//	Copyright (c) 1992, 1993, 1994, 1995 Bjorn Backlund.  
//	All rights reserved. 
//

#import "filter.h"

@implementation Cosmo_Filter

- (void)initListener;
{
	const char *name = [self appName];
	
    // Create a Listener object
    
	appListener = [[Listener alloc] init];
	
    // Check in a MACH port with name == application name
    
	if([appListener checkInAs: name] != 0)
		NXLogError("ERROR: Could not check in MACH port %s!", 
				name);
		
    // Tell Listner that incoming messages should be
    // forwarded to me
		
	[appListener setDelegate:self];
	[appListener setServicesDelegate: self];

    // Install the MACH port 
    
	[appListener addPort];
}

- runAsUNIXFilter;
{
    // For debugging purposes we allow that the filter be
    // called from the command line
	
	if(NXArgv[1] != NULL && strcmp(NXArgv[1], "-file") == 0) {
	
		strcpy(theFile, NXArgv[2]);
		thePasteboard = [Pasteboard new];
		
		[self convertFile];
		
		return self;
	}
	
	return nil;
}

- run;
{
    // Check if we should run as an ordinary UNIX filter
    
    	if([self runAsUNIXFilter] != nil)
		return self;
		
    // Create the Listener
    
	[self initListener];

    // Tell Listener to run
    
	[Listener run];		// Never returns
	
	return self;
}

@end


