//
//	Copyright (c) 1995 Bjorn Backlund.  
//	All rights reserved. 
//

#import "filter.h"

@implementation Cosmo_Filter (Filtering)

- openDocument;
{
	id aDocument;
	
    // Create a Cosmo document object
    
	aDocument = [[Cosmo_Doc allocFromZone:[self zone]] init];
	
    // Tell it to read data from the file
    
    	[aDocument openDocumentFrom:theFile];
	
    // Extension: set theError if file couldn't be opened
    
    // Return the document
    
	return aDocument;
}


- convertFile;
{
	id aDocument = nil;
	
    // Open Cosmo document from file 
    
	aDocument = [self openDocument];
	
	if(aDocument == nil) {
		theError = 2;
		goto exit;
	}
	
    // Tell document to add itself to the pasteboard
    
    	[aDocument addToFileFilterOOEPasteboard: thePasteboard];
	
    exit:
    	
	if(aDocument) [aDocument free];

	return self;
}

- (int)cosmo2ooe:aPasteboard
    userData:(const char *)userData
    error:(char **)msg
{
	char *data = NULL; 
	int length = 0;
	const char *filetype = "NXTypedFilenamePboardType:cosmo";
	const char *type = NULL;
	
    // Return theError = 0 if file could be filtered
    
    	theError = 0;
	
    // Check there is a filename on the pasteboard
    
	type = [aPasteboard findAvailableTypeFrom: &filetype num:1];
	
	if(type == NULL) {
		*msg = "No NXTypedFilenamePboardType:cosmo in pboard";
		NXLogError(*msg);
		return 1;
	}
	
    // Get the file to filter from the pasteboard
    
	[aPasteboard readType:filetype 
		data: &data 
		length: &length];
			
    //	Store the file to filter and the pasteboard
    
    	strcpy(theFile, data);
	thePasteboard = aPasteboard;

    // Filter the file
    
	[self convertFile];
    	
    // Free filename
    
	[aPasteboard deallocatePasteboardData: data
		length: length];
    
	return theError;
}

@end


