//
//	Xanthus
//	Copyright (c) 1992, 1993, 1994 Bjorn Backlund & Jesper Lundh.  
//	All rights reserved. 
//



#import "draw.h"

#ifdef 	OOE_SERVER


int OOE_Is_Debug = 0;	

int OOE_Drawing = 0;

int OOE_Version = 1;
int OOE_Version_CanOpen = 1;

int OOE_Document = 0;		// OOE 2.0

 
NXAtom OOE_ApplicationPboardType = NULL;
NXAtom OOE_PboardType = NULL;

 
@implementation DrawDocument (OOE_Server)

+ (void)initialize_OOE;	// OOE 2.0
{
	if(OOE_ApplicationPboardType == NULL)
		OOE_ApplicationPboardType = 
			NXUniqueString(OOE_APPINFO_PASTEBOARDTYPE);
			
	
	if(OOE_PboardType == NULL)
		OOE_PboardType = 
			NXUniqueString(PBOARDTYPE);
			
	
}

#ifndef DRAW_FILTER		// OOE 2.0
- setTitle_OOE:sender;
{
	char buf[MAXPATHLEN+1];
	
	if(theOOEClientProxy == nil && isOOEServer) {
	
		strcpy(buf, "Embedded: **** DEAD EDITOR ****");
		
	} else if(theOOEClientPath == NULL) {
	
		strcpy(buf, "Embedded: UNTITLED");
	
	} else { 
	
		sprintf(buf, "Embedded: %s", theOOEClientPath);
	}
	
	[[window contentView] ooeStatusChanged:self];	// OOE 2.0
	
	[window setTitle:buf];
	
	return self;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
- docWillClose_OOE:sender;
{
	if(theOOEClientProxy == nil) return self;
	
	if(!isOOEServer) return self;
	
	[[theOOEClientProxy connectionForProxy] 
		unregisterForInvalidationNotification:self];
	
	NX_DURING
		[theOOEClientProxy OOE_documentWillClose:self];	
	NX_HANDLER
		NXLogError("DOC %s, OOE: Error %d for "
				"'OOE_documentWillClose:'",
				[self name],
				NXLocalHandler.code);
	NX_ENDHANDLER
	
	[NXConnection removeObject:self];

	return self;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
- free_OOE;
{
	NX_DURING
	
		//[theOOEClientProxy free];	// 940824
						// causes timeout
						// why?
		
		theOOEClientProxy = nil;
		
	NX_HANDLER
		
		if(OOE_Is_Debug)
			NXLogError("ERROR, DOC, OOE: Error %d when "
					"freeing theOOEClientProxy.",
					NXLocalHandler.code);
			
	NX_ENDHANDLER
	
	if(theOOEClientPath != NULL) {
		NX_FREE(theOOEClientPath);
		theOOEClientPath=NULL;
	}
	
	return self;
}
#endif

- clipRect;
{
	return [view clipRect];
}

- getBBox: (NXRect *)aRect;	// OOE 2.0
{
	id cr = [view clipRect];

	if(cr) [cr getBounds: aRect];
	else [view getBBox:aRect of:[view graphics]];
	
	return self;
}

- getClipRect;			// OOE 2.0
{
	id cr = [view clipRect];
	NXRect aRect;
	
	if(cr == nil) {
	
		cr = [[Rectangle_OOE allocFromZone:[self zone]] 
					init];	
					
		[view getBBox:&aRect of:[view graphics]];
		[cr setBounds: &aRect];
		
		[view insertGraphic:cr];
	
	}
	
	return cr;
}


#ifndef DRAW_FILTER		// OOE 2.0
- initForNewOOEClient:client;
{
	NXRect ooeRect = {380, 230, 390, 410};
	id clipRectangle;
	
	[window placeWindow: &ooeRect];
	
    // get myself a clip rectangle
    
	clipRectangle = [[Rectangle_OOE allocFromZone:[self zone]] init];
	[view insertGraphic:clipRectangle];

    // connect to the OOE client
    
	[self OOE_connectToClient:client];
	
    // bring window to front
    
    	[window makeKeyAndOrderFront:self];
	 
	return self;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
- initForOldOOEClient:client;
{
	[self OOE_connectToClient:client];
	
	[self getClipRect];	// OOE 2.0
	
    	[window makeKeyAndOrderFront:self];
	
	return self;
}
#endif

- (int)isOOEServer;
{
	return isOOEServer;
}

#ifndef DRAW_FILTER		// OOE 2.0
- (int)OOE_connectToClient:client;
{
	id connectionToClient;
	const char *path = NULL;
	 
	if(OOE_Is_Debug) 
		NXLogError("DOC %s: OOE_connectToClient: = %s", 
				[self name],
				[client name]);

	isOOEServer = YES;
	theOOEClientProxy = client;

    	connectionToClient = [client connectionForProxy];
    	[connectionToClient registerForInvalidationNotification:self];
      	  
    	[client setProtocolForProxy:@protocol(OOE_ClientInterface)];
	
	NX_DURING
		path = [client OOE_documentPath:self];
	NX_HANDLER
		NXLogError("DOC %s, OOE: Error %d for 'OOE_documentPath:'",
				[self name],
				NXLocalHandler.code);
	NX_ENDHANDLER
	
	
	[self OOE_document: client savedAs:path];
	
	return 1;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
- senderIsInvalid:sender;
{
	if(theOOEClientProxy == nil) {
		if(OOE_Is_Debug)
			NXLogError("OOE, DOC (Non Server) %s, INVALID: %s", 
				[self name],
				[sender name]);
		return self;
	}
	
	if(OOE_Is_Debug)
		NXLogError("OOE, DOC %s: INVALID: %s", 
			[self name],
			[sender name]);
	

	theOOEClientProxy = nil;
	
	[self setTitle_OOE:self];
	
    	return self;
}
#endif

//
//
//

#ifndef DRAW_FILTER		// OOE 2.0
- updateOOETarget:sender;
{
	if(OOE_Is_Debug) 	
		NXLogError("DOC %s: updateOOETarget:",
			[self name]);
	
	[theOOEClientProxy OOE_documentWasChanged:self];
	[theOOEClientProxy OOE_orderClientDocumentFront:self];

	return self;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
- orderClientDocumentFront:sender;	// OOE 2.0
{
	if(OOE_Is_Debug) NXLogError("DOC: orderClientDocumentFront:");
	
	[theOOEClientProxy OOE_orderClientDocumentFront:self];

	return self;
}
#endif

//
// OOE_DocumentInterface
//

#ifndef DRAW_FILTER		// OOE 2.0
- (int)OOE_sizeTo:(NXCoord)w:(NXCoord)h;
{
	NXRect aRect;
	
	if(OOE_Is_Debug) NXLogError("DOC %s: OOE_sizeTo:", 
					[self name]);

	[[self clipRect] getBounds: &aRect];
	NX_WIDTH(&aRect) = w;
	NX_HEIGHT(&aRect) = h;
	[[self clipRect] setBounds:&aRect];
	
	return 1;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
- (int)OOE_getSize:(NXSize *)aSize;
{
	NXRect aRect = {0,0,300,300};	
	
	if(OOE_Is_Debug) NXLogError("DOC %s: OOE_getSize:", 
					[self name]);

	[[self clipRect] getBounds: &aRect];
	*aSize = aRect.size;
	
	return 1;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
- (int)OOE_orderDocumentFront:sender;
{
	if(OOE_Is_Debug) NXLogError("DOC %s: OOE_orderDocumentFront:",
				[self name]);

	[NXApp activateSelf:YES];
	[window makeKeyAndOrderFront:nil];
	
	return 1;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
- (void)OOE_closeDocument:sender;
{
	if(OOE_Is_Debug) 
		NXLogError("DOC %s: OOE_closeDocument:",
			[self name]);

	isOOEServer = 0;

	[self clean:self];
	[self close:self];
	
	return; 
}
#endif


#ifndef DRAW_FILTER		// OOE 2.0
- (int)OOE_document: client savedAs:(const char *)path;
{
	if(path == NULL) path = "UNTITLED";
	
	theOOEClientPath = NXCopyStringBuffer(path);
	
	[self setName: theOOEClientPath andDirectory:NULL];
	
	return 1;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
- (int)OOE_isDocEdited;
{
	if(OOE_Is_Debug) 
		NXLogError("DOC %s: OOE_isDocEdited", [self name]);

	return [window isDocEdited]; 
}
#endif

//
// OOE Data Transfer
//


#ifndef DRAW_FILTER		// OOE 2.0
- OOE_retrieveDocFromPasteboard: (char *)frameString;
{
	id pboard;
	NXStream *stream = NULL;
	id retval = nil;
	
 	if(OOE_Is_Debug) 
		NXLogError("DOC: OOE_retrieveDocFromPasteboard:");

	pboard = [Pasteboard newName: OOE_PASTEBOARD];
	if(pboard == nil) {
	
		NXLogError("ERROR: No '%s' pasteboard!",
				OOE_PboardType);
		return nil;
	}
	
	[pboard types];

	stream = [pboard readTypeToStream: OOE_PboardType];
	if(stream == NULL) {
	
		NXLogError("ERROR: No '%s' type in pasteboard '%s'!",
				OOE_PboardType, OOE_PASTEBOARD);
		return nil;
	}
	
	retval = [self readOOEDocFrom:stream 
				frame: frameString];
			
	if(stream)
		NXCloseMemory(stream, NX_FREEBUFFER);	// 941113
				
	return retval;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
- promptOldOOEVersion;
{
	[NXApp reportOOEProblem: "OOE Version Problem"
	
		format: "The OOE object has been created with "
			"an older version of %s "
			"and can't be opened!",
		
			[NXApp appName]];
	
	return self;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
- promptNewOOEVersion;
{
	[NXApp reportOOEProblem: "OOE Version Problem"
	
		format: "The OOE object has been created "
			"with a newer version of %s "
			"and can't be opened!",
		
			[NXApp appName]];
	
	return self;
}
#endif


#ifndef DRAW_FILTER		// OOE 2.0
- readOOEDocFrom:(NXStream *)stream	
		frame: (char *)frameString;				
{
	NXTypedStream *ts = NULL;
	int diskOOEVersion = 0;
	//
	char *s;
	int cgi, version;
	id retval = self;
	
 	if(OOE_Is_Debug) 
		NXLogError("DOC: readOOEDocFrom:");

    // open a typed stream
    
	ts = NXOpenTypedStream(stream, NX_READONLY);
	if(ts == NULL) {
		NXLogError("ERROR, DOC, OOE, readOOEDocFrom"
				"Could not open typed stream!");
		return nil;
	}
	
	NXSetTypedStreamZone(ts, [self zone]);
    	
    // read ooe version
    
    	NX_DURING
		NXReadType(ts, "i", &diskOOEVersion);
    	NX_HANDLER
		retval = nil;
    	NX_ENDHANDLER
	
    // check versions
    
	if(diskOOEVersion < OOE_Version_CanOpen) {
	   
		[self promptOldOOEVersion];
		NXCloseTypedStream(ts);
		return nil;
		
	}

	if((diskOOEVersion > OOE_Version) > 0) {
	    
		[self promptNewOOEVersion];
		NXCloseTypedStream(ts);
		return nil;
		
	}

    	NX_DURING
	
		NXReadType(ts, "i", &version);
		
		printInfo = NXReadObject(ts);
		
		NXReadType(ts, "*", &s);
		if (frameString) strcpy(frameString, s);
		free(s);
		
		NXReadType(ts, "i", &cgi);
		[Graphic updateCurrentGraphicIdentifier:cgi];
		
		view = NXReadObject(ts);
    
	NX_HANDLER
		NXLogError("ERROR, DOC: Error %d for readOOEDocFrom:",
				NXLocalHandler.code);
	    	retval = nil;
	NX_ENDHANDLER
	
	return retval;
}
#endif

#ifndef DRAW_FILTER		// OOE 2.0
+ OOE_newFromPasteboard
{
	NXZone *zone;
	NXRect contentViewFrame = {0,0,100, 100};
	char frameString[NX_MAXFRAMESTRINGLENGTH];
    
 	if(OOE_Is_Debug) 
		NXLogError("DOC: OOE_newFromPasteboard:");

	zone = [self newZone];
	self = [super allocFromZone:zone];
	[self init];
	
	[self OOE_retrieveDocFromPasteboard:frameString];	

	window = createWindowFor(view, &contentViewFrame, *frameString ? 
					frameString : NULL);
	[window setDelegate:self];
	[self resetScrollers];
	haveSavedDocument = YES;
	
	return self;
}
#endif


//
//
//


#ifndef DRAW_FILTER		// OOE 2.0
- (int)OOE_provideData:sender;
{
	id pboard;
	const char *types[16];
	int k = 0;
	
	pboard = [Pasteboard newName: OOE_PASTEBOARD];
	
 	if(OOE_Is_Debug) 
		NXLogError("DOC %s: OOE_provideData:", [self name]);

	types[k++] = NXPostScriptPboardType;
	types[k++] = OOE_PboardType;
	[pboard declareTypes: types 
		num: k 
		owner: NXApp];	
	
	[self addAsOOEDocTo:pboard];

	[window setDocEdited:NO];
	
 	if(OOE_Is_Debug) 
		NXLogError("DOC %s: EXIT OOE_provideData:",
				 [self name]);
	
	return 1;
}
#endif




- addAsOOEDocTo:pboard;		// OOE 2.0 
{
	NXStream *epsStream;
	NXStream *docStream;
	
 	if(OOE_Is_Debug) 
		NXLogError("DOCx: addAsOOEDocTo: '%s'", [pboard name]);

   	epsStream = NXOpenMemory(NULL, 0, NX_WRITEONLY);
    	[self copyAsEPSTo: epsStream];
	
    	docStream = NXOpenMemory(NULL, 0, NX_WRITEONLY);
    	[self copyAsOOEDocTo: docStream];
	
	NXSeek(epsStream, 0, NX_FROMSTART);
	NXSeek(docStream, 0, NX_FROMSTART);
	
	[pboard writeType: NXPostScriptPboardType
		fromStream:epsStream];
	[pboard writeType: OOE_PboardType
		fromStream:docStream];
		
	NXCloseMemory(epsStream, NX_FREEBUFFER);
	NXCloseMemory(docStream, NX_FREEBUFFER);

 	if(OOE_Is_Debug) 
		NXLogError("DOCx: EXIT addAsOOEDocTo:");
	
	return self;
}

- copyAsEPSTo:(NXStream *)stream;				
{
	NXRect aRect = {0,0,300,300};	
	
 	if(OOE_Is_Debug) 
		NXLogError("DOC %s: copyAsEPSTo:", [self name]);

	OOE_Drawing = 1;
	
	[self getBBox: &aRect];
	
	NX_WIDTH(&aRect) += 1;
	NX_HEIGHT(&aRect) += 1;
	
	NX_DURING
		[view copyPSCodeInside:&aRect to:stream];
	NX_HANDLER
		NXLogError("DOC, OOE, (%s), Error %d for copyPSCodeInside:",
				NXLocalHandler.code);
	NX_ENDHANDLER

	OOE_Drawing = 0; 
	
	return self;
}

- copyAsOOEDocTo:(NXStream *)stream;		// OOE 2.0		
{
	return [view writeOOEToStream:stream];
}

/*
- copyAsOOEDocTo:(NXStream *)stream;				
{
	NXTypedStream *ts;
	int ooeVersion = OOE_Version;
	int cgi, version;
    	char *s;
    	char buffer[MAXPATHLEN+1];
	
 	if(OOE_Is_Debug) 
		NXLogError("DOC %s: copyAsOOEDocTo:", [self name]);

	ts = NXOpenTypedStream(stream, NX_WRITEONLY);
	if(ts == NULL) {
		NXLogError("ERROR, DOC, OOE, copyAsOOEDocTo"
				"Could not open typed stream!");
		return nil;
	}
	
	
 	NX_DURING

	[window makeFirstResponder:view];

   // write version
	
	NXWriteType(ts, "i", &ooeVersion);		// ooe version

    // write data (copied from the save; method)
    
	version = NEW_DRAW_VERSION;
	[window makeFirstResponder:view];
	
	NXWriteType(ts, "i", &version);	
	NXWriteRootObject(ts, printInfo);
	
	[window saveFrameToString:(s = buffer)];
	NXWriteType(ts, "*", &s);
	
	cgi = [Graphic currentGraphicIdentifier];
	NXWriteType(ts, "i", &cgi);
	
	NXWriteRootObject(ts, view);
	  
	NX_HANDLER
		NXLogError("ERROR, DOC %s: Error %d for write data "
			"in copyAsOOEDocTo:",
			NXLocalHandler.code);
	NX_ENDHANDLER
	
    // close typed stream
    
	NX_DURING
		NXCloseTypedStream(ts);
	NX_HANDLER
		NXLogError("ERROR, DOC %s: Error %d for NXCloseTypedStream()"
			"in copyAsOOEDocTo:",
			NXLocalHandler.code);
	NX_ENDHANDLER
	
 	if(OOE_Is_Debug) 
		NXLogError("DOC %s: EXIT copyAsOOEDocTo:",
				[self name]);
	
	return self;
}
*/

//
//
//


@end

#endif

