#ifndef DRAW_FILTER		// OOE 2.0

#import "draw.h"

#import "GraphicView_C_Grouping.h"

@implementation GraphicView (Grouping)

- group:sender
/*
 * Creates a new Group object with the current slist as its member list.
 * See the Group class for more info.
 */
{
    int i;
    NXRect eb;
    Graphic *graphic;
    id change;

    i = [slist count];
    if (i > 1) {
	change = [[GroupGraphicsChange alloc] initGraphicView:self];
	[change startChange];
	    while (i--) [glist removeObject:[slist objectAt:i]];
	    graphic = [[Group allocFromZone:[self zone]] initList:slist];
	    [change noteGroup:graphic];
	    [glist insertObject:graphic at:0];
	    slist = [[List allocFromZone:[self zone]] init];
	    [slist addObject:graphic];
	    gvFlags.groupInSlist = YES;
	    [self cache:[graphic getExtendedBounds:&eb]];
	    if (sender != self) [window flushWindow];
	[change endChange];
    }

    return self;
}


- ungroup:sender
/*
 * Goes through the slist and ungroups any Group objects in it.
 * Does not descend any further than that (i.e. all the Group objects
 * in the slist are ungrouped, but any Group objects in those ungrouped
 * objects are NOT ungrouped).
 */
{
    int i, k;
    NXRect sbounds;
    id graphic;
    id change;

    if (!gvFlags.groupInSlist || [slist count] == 0)
        return nil;
	
    change = [[UngroupGraphicsChange alloc] initGraphicView:self];
    [change startChange];
	[self getBBox:&sbounds of:slist];
	i = [slist count];
	while (i--) {
	    graphic = [slist objectAt:i];
	    if ([graphic isKindOf:[Group class]]) {
		k = [glist indexOf:graphic];
		[glist removeObjectAt:k];
		[graphic transferSubGraphicsTo:glist at:k];
	    }
	}
    	[self cache:&sbounds];
	if (sender != self) [window flushWindow];
	[self getSelection];
    [change endChange];
    
    return self;
}


@end

#endif

