#ifndef DRAW_FILTER		// OOE 2.0


#import "draw.h"

@interface GraphicView (Links)

- (NXSelection *)currentSelection;
- (Graphic *)findGraphicInSelection:(NXSelection *)selection;
- (List *)findGraphicsInSelection:(NXSelection *)selection;

- writeLinkToPasteboard:(Pasteboard *)pboard types:(const NXAtom *)typesList;
- (BOOL)addLink:(NXDataLink *)link toGraphic:(Graphic *)graphic at:(const NXPoint *)p update:(int)update;

- pasteFromPasteboard:(Pasteboard *)pboard at:(NXSelection *)selection;
- importFile:(const char *)filename at:(NXSelection *)selection;
- pasteboard:(Pasteboard *)sender provideData:(const char *)type;
- copyToPasteboard:(Pasteboard *)pboard at:(NXSelection *)selection cheapCopyAllowed:(BOOL)cheapCopyAllowed;

- updateLinksPanel;
- (NXDataLinkManager *)linkManager;
- setLinkManager:(NXDataLinkManager *)linkManager;
- showSelection:(NXSelection *)selection;
- breakLinkAndRedrawOutlines:(NXDataLink *)aLink;
- updateTrackedLinks:(const NXRect *)rect;
- startTrackingLink:(NXDataLink *)link;
- stopTrackingLink:(NXDataLink *)link;

@end


#endif

