//
//	Xanthus
//	Copyright (c) 1992-95 Bjorn Backlund.  
//	All rights reserved. 
//

#import "draw.h"

#import "GraphicView_C_Pasteboard_OOE.h"

@implementation GraphicView (Pasteboard_OOE)

//
// OOE 2.0
//

+ addAppInfoToPboard:pboard;
{
	NXAtom type = OOE_ApplicationPboardType;
	const char *appname = "Draw++";
		
	if(OOE_Is_Debug) 
		NXLogError("VIEW: addAppInfoToPboard: %s",
		 		[pboard name]);

    // write appname to pboard
    
    	[pboard writeType: type
		data: appname
		length: strlen(appname)];
	
	return self;
}


//
// OOE 2.0
// Sent to the scarpper object
// Create OOE data ==
//

- writeOOEToStream:(NXStream *)stream usingList:list;
{
	List *savedglist;
	
	savedglist = glist;
	glist = list;
	[self writeOOEToStream:stream];
	glist = savedglist;
	
	return self;
}

//
// This method was originally (OOE 1.0) in DrawDocument_OOE
// and was then called copyAsOOEDocTo:
//
- writeOOEToStream:(NXStream *)stream;
{
	NXTypedStream *ts;
	int ooeVersion = OOE_Version;
	int cgi, version;
    	char *s;
    	char buffer[MAXPATHLEN+1];
	
 	if(OOE_Is_Debug) 
		NXLogError("VIEW: writeOOEToStream:");

	ts = NXOpenTypedStream(stream, NX_WRITEONLY);
	if(ts == NULL) {
		NXLogError("ERROR, VIEW, OOE, writeOOEToStream"
				"Could not open typed stream!");
		return nil;
	}
	
	
    NX_DURING

   // write version
	
	NXWriteType(ts, "i", &ooeVersion);		// ooe version

    // write data (copied from the save; method)
    
	version = NEW_DRAW_VERSION;
	
	NXWriteType(ts, "i", &version);	
	NXWriteRootObject(ts, [NXApp printInfo]);	// Not really accurate
							// Should be printInfo
							// of document.
							// But Draw's original
							// copy code forced
							// us to do this
	
	[window saveFrameToString:(s = buffer)];
	NXWriteType(ts, "*", &s);
	
	cgi = [Graphic currentGraphicIdentifier];
	NXWriteType(ts, "i", &cgi);
	
	NXWriteRootObject(ts, self);
	  
    NX_HANDLER
		NXLogError("ERROR, VIEW %s: Error %d for write data "
				"in writeOOEToStream:",
				NXLocalHandler.code);
    NX_ENDHANDLER
	
    // close typed stream
    
    NX_DURING
		NXCloseTypedStream(ts);
    NX_HANDLER
		NXLogError("ERROR, VIEW %s: Error %d for NXCloseTypedStream()"
			"in writeOOEToStream:",
			NXLocalHandler.code);
    NX_ENDHANDLER
	
 	if(OOE_Is_Debug) 
		NXLogError("VIEW: EXIT: writeOOEToStream:");
	
	return self;
}


@end


