//
//	Xanthus
//	Copyright (c) 1992-95 Bjorn Backlund.  
//	All rights reserved. 
//

#import "draw.h"

#import "GraphicView_C_Pasteboard_TargetAction.h"

@implementation GraphicView (Pasteboard_TargetAction)

/* Pasteboard-related target/action methods */

#ifndef DRAW_FILTER		// OOE 2.0
- cut:sender
/*
 * Calls copy: then delete:.
 */
{
    id change;

    if ([slist count] > 0) {
	change = [[CutGraphicsChange alloc] initGraphicView:self];
	[change startChange];
	    [self copy:sender];
	    lastCutChangeCount = lastCopiedChangeCount;
	    [self delete:sender];
	    consecutivePastes = 0;
        [change endChange];
	return self;
    } else {
	return nil;
    }
}
#endif




#ifndef DRAW_FILTER		// OOE 2.0
- copy:sender
{
    if ([slist count]) {
	[self copyToPasteboard:[Pasteboard new]];
	lastPastedChangeCount = [[Pasteboard new] changeCount];
	lastCopiedChangeCount = [[Pasteboard new] changeCount];
	consecutivePastes = 1;
	originalPaste = [slist objectAt:0];
    }
    return self;
}
#endif





#ifndef DRAW_FILTER		// OOE 2.0
- paste:sender
{
    return [self paste:sender andLink:DontLink];
}
#endif



#ifndef DRAW_FILTER		// OOE 2.0
- pasteAndLink:sender
{
    return [self paste:sender andLink:Link];
}
#endif



#ifndef DRAW_FILTER		// OOE 2.0
- link:sender
{
    return [self paste:sender andLink:LinkOnly];
}
#endif


@end


