#ifndef DRAW_FILTER		// OOE 2.0

#import "draw.h"

#import "GraphicView_C_Scrolling.h"

@implementation GraphicView (Scrolling)

/* Useful scrolling routines. */

- scrollGraphicToVisible:(Graphic *)graphic
{
    NXPoint p;
    NXRect eb;

    p = bounds.origin;
    NXContainRect([graphic getExtendedBounds:&eb], &bounds);
    p.x -= bounds.origin.x;
    p.y -= bounds.origin.y;
    if (p.x || p.y) {
	[graphic moveBy:&p];
	bounds.origin.x += p.x;
	bounds.origin.y += p.y;
	[self scrollRectToVisible:[graphic getExtendedBounds:&eb]];
    }

    return self;
}

- scrollPointToVisible:(const NXPoint *)point
{
    NXRect r;

    r.origin.x = point->x - 5.0;
    r.origin.y = point->y - 5.0;
    r.size.width = r.size.height = 10.0;

    return [self scrollRectToVisible:&r];
}

- scrollSelectionToVisible
{
    NXRect sbounds;

    if ([slist count]) {
	[self getBBox:&sbounds of:slist];
	return [self scrollRectToVisible:&sbounds];
    }

    return self;
}


@end


#endif

