#ifndef DRAW_FILTER		// OOE 2.0

#import "draw.h"

#import "GraphicView_C_Spelling.h"

@implementation GraphicView (Spelling)

- spellCheck:sender
{
    int i;
    NXCoord curY, newY, maxY = 0.0;
    NXCoord curX, newX, maxX = 0.0;
    NXRect egbounds, gbounds;
    id fr = [window firstResponder];
    Graphic *graphic, *editingGraphic, *newEditingGraphic = nil;

    if (![fr isKindOf:[Text class]] || ![[NXSpellChecker sharedInstance] checkSpelling:NX_CheckSpellingToEnd of:fr]) {
	if ([fr isKindOf:[Text class]]) {
	    editingGraphic = [fr delegate];
	    [editingGraphic getBounds:&egbounds];
	    curY = egbounds.origin.y + egbounds.size.height;
	    curX = egbounds.origin.x;
	} else {
	    curX = 0.0;
	    curY = 10000.0;
	}
	maxY = 0.0; maxX = 10000.0;
	for (i = [glist count]-1; i >= 0; i--) {
	    graphic = [glist objectAt:i];
	    if ([graphic isKindOf:[TextGraphic class]]) {
		[graphic getBounds:&gbounds];
		newY = gbounds.origin.y + gbounds.size.height;
		newX = gbounds.origin.x;
		if ((newY > maxY || (newY == maxY && newX < maxX)) && (newY < curY || (newY == curY && newX > curX))) {
		    maxY = newY;
		    maxX = newX;
		    newEditingGraphic = graphic;
		}
	    }
	}
	[window makeFirstResponder:self];
	if (newEditingGraphic) {
	    [newEditingGraphic edit:NULL in:editView];
	    return [self spellCheck:sender];
	}
    }

    return self;
}

- showGuessPanel:sender
{
    return [[[NXSpellChecker sharedInstance] spellingPanel] 
    			makeKeyAndOrderFront:sender];
}

@end


#endif


