//
//	Xanthus
//	Copyright (c) 1992-95 Bjorn Backlund.  
//	All rights reserved. 
//

#import "filter_all.h"

int FilterDebug = 0;


@implementation FilterApp

- loadDebugFlags;
{
	const char *d;
	
	if(FilterDebug) return self;
	
	d = NXGetDefaultValue([self appName], "Debug");
	
	FilterDebug = (d != NULL && strcmp(d, "Yes") == 0);
	
	return self;
}

- run;
{
	[self loadDebugFlags];

    	if(FilterDebug) { 
		NXLogError("Filter called with:");
		NXLogError("\targc = %d", NXArgc);
		NXLogError("\targc[0] = %s", NXArgv[0]);
		NXLogError("\targc[1] = %s", NXArgv[1]);
		NXLogError("\targc[2] = %s", NXArgv[2]);
	}
	
    // convert command line file?
    
	if(NXArgc >= 3) {
	
		if(strcmp(NXArgv[1], "-eps") == 0) {
		
			strcpy(theFile, NXArgv[2]);
			
			[self convertDrawFileToEPS];
			return self;
		
		}
	
		if(strcmp(NXArgv[1], "-ooe") == 0) {
		
			strcpy(theFile, NXArgv[2]);
			
			[self convertDrawFileAsOOETo:nil];
			return self;
		
		}
	
	}
	
    // start listening
    
	[self initListener];

	if(appListener == nil)
		NXLogError("ERROR: No listener!");
		
    	if(FilterDebug) {
		NXLogError("Filter: listenting on %s...", 
				[appListener portName]);
	}
	
	[Listener run];	// Never returns
	
	return self;
}

- (void)initListener;
{
	const char *name = [self appName];
	
    	if(FilterDebug) {
		NXLogError("Filter: checking in %s...", name);
	}

	appListener = [[Listener alloc] init];
	
	if([appListener checkInAs: name] != 0)
		NXLogError("ERROR: Could not check in port %s!", 
				name);
		
	[appListener setDelegate:self];
	[appListener setServicesDelegate: self];

	[appListener addPort];
}


- (const char *)appName;
{
	return "drawFilter";
}

//
//
//

- openDrawFile;
{
	theDocument = [DrawDocument newFromFile:theFile andDisplay:NO];
	
	return theDocument;
}


@end


