//
//	Xanthus
//	Copyright (c) 1992-95 Bjorn Backlund.  
//	All rights reserved. 
//

#import "filter_all.h"

#import "FilterApp_C_OOE.h"

@implementation FilterApp (OOE)

- (int)draw2ooe:pb
    userData:(const char *)userData
    error:(char **)msg
{
	char *data = NULL; 
	int length = 0;
	const char *filetype = "NXTypedFilenamePboardType:draw";
	const char *type = NULL;
	
    	if(FilterDebug)
		NXLogError("Filter: draw2ooe -> %s", [pb name]);
	
	type = [pb findAvailableTypeFrom: &filetype num:1];
	
    // not ok?
    
	if(type == NULL) {
		*msg = "No NXTypedFilenamePboardType:draw in pboard";
		NXLogError(*msg);
		return 1;
	}
	
    // get filename
    
	[pb readType:filetype 
		data: &data 
		length: &length];
			
	if(FilterDebug) NXLogError("Filter: file = %s.", data);
		
    //	do the actual conversion
		
	strcpy(theFile, data);
	[self convertDrawFileAsOOETo:pb];
    	
    // free filename
    
	[pb deallocatePasteboardData: data
		length: length];
    
	return 0;
}

- convertDrawFileAsOOETo:pb;
{	
    	NXAtom rettypes[8];
	int k = 0;
	
	if(pb == nil)
		pb = [Pasteboard newName: NXGeneralPboard];
		
    // open
    
    	[self openDrawFile];
	if(theDocument == nil) return nil;
	
     // declare eps, app info and document to pboard
    
	rettypes[k++] = NXPostScriptPboardType; 
	rettypes[k++] = OOE_ApplicationPboardType; 
	rettypes[k++] = OOE_PboardType; 
	
	[pb declareTypes:rettypes 
		num:k 
		owner:self];
   
    // add app info
    
    	[GraphicView addAppInfoToPboard:pb];
	
    // add eps and doc
    
    	[theDocument addAsOOEDocTo:pb];
		
    // exit
    
    	[theDocument close];
	theDocument = nil;
	
	return self;
}

@end


