//
//	Xanthus
//	Copyright (c) 1992, 1993, 1994 Bjorn Backlund & Jesper Lundh.  
//	All rights reserved. 
//

#import "draw.h"

// This class implements the rectangle used to specify the
// rectangle which should be sent back
// to the OOE client

@implementation Rectangle_OOE

- init;
{
	[super init];
	
	NX_X(&bounds) = 30;
	NX_Y(&bounds) = 30;
	NX_WIDTH(&bounds) = 300;
	NX_HEIGHT(&bounds) = 300;
	
	linewidth = 0.15;
	
	return self;
}

- (BOOL)isOpaque
{
    return NO;
}

// Don;t accept color dropping
- (Graphic *)colorAcceptorAt:(const NXPoint *)point
{
    return nil;
}

+ (BOOL)isEditable
{
    return NO;
}

+ (BOOL)isDeletable
{
    return NO;
}

+ (BOOL)isDragSelectable
{
    return NO;
}



- (BOOL)mightBeLinked
{
	return NO;
}

- (BOOL)canEmitEPS
{
    return NO;
}

- (BOOL)canEmitTIFF
{
    return NO;
}

//
//
//

- draw
{
    float pattern[] = {3.0, 3.0};	

    #ifndef DRAW_FILTER		//
    if(OOE_Drawing) return self;
    #endif
    
    if (bounds.size.width < 1.0 || bounds.size.height < 1.0) return self;

    NXSetColor(NX_COLORRED);
    
    PSsetdash(pattern, 2, 0.0);	
    PSrectstroke(bounds.origin.x, 
    		bounds.origin.y, 
		bounds.size.width, 
		bounds.size.height);
    PSsetdash(0, 0, 0.0);	

    return self;
}

#ifndef DRAW_FILTER		//
- (BOOL)borderHit:(const NXPoint *)p
{
    NXRect inner = bounds;
    NXRect outer = bounds;
    
    NXInsetRect(&inner, 4, 4);
    NXInsetRect(&outer, -4, -4);
    
    return !NXMouseInRect(p, &inner, NO) && NXMouseInRect(p, &outer, NO);
}
#endif


- (BOOL)hit:(const NXPoint *)p
{
	return [self borderHit:p];	// OOE 2
}

//
// disable props
//

- setLineColor:(const NXColor *)color
{
	return self;
}

- setLineWidth:(const float *)value
{
    return self;
}

- setFillColor:(const NXColor *)color
{
	return self;
}

- setGray:(const float *)value
{
    return self;
}

- setFill:(int)mode
{
    return self;
}

@end