//
//	Xanthus
//	Copyright (c) 1992, 1993, 1994 Bjorn Backlund & Jesper Lundh.  
//	All rights reserved. 
//

#import "app.h"


int OOE_Is_Debug = 0;	

int OOE_Drawing = 0;

int OOE_Version = 1;
int OOE_Version_CanOpen = 1;


@implementation YapApp (OOE_Server)

#define OOE_SERVER_NAME "Yap++_OOE_Server"

- initOOEServer; 
{
	const char *val = NULL;
	id aConnection = [NXConnection registerRoot: self
				withName: OOE_SERVER_NAME];
	
	
	val = (STR)NXGetDefaultValue([NXApp appName], "OOE_Is_Debug");
	if(val == NULL) val = "";
	OOE_Is_Debug = (strcasecmp(val,"Yes") == 0);
	
	if(OOE_Is_Debug)
		 NXLogError("OOE %s: initOOEServer", [NXApp appName]);

	[aConnection registerForInvalidationNotification:self];
	[aConnection runFromAppKit];	
	
	return self;
}

- senderIsInvalid:sender;
{
	if(OOE_Is_Debug)
		 NXLogError("OOE %s: SENDER INVALID: %s", 
		 	[NXApp appName],
		 	[sender name]);
		 
    	return self;
}

//
// OOE_ServerInterface
// 

- OOE_newDocument:client;
{
	id doc = [YapDocument newForOOE];
	
	[doc initForNewOOEClient:client];
	
	return doc;
}

- OOE_openDocument:client;
{
	id doc = [YapDocument newForOOE];
	
	[doc initForOldOOEClient:client];

	return doc;
}


//
// Utilities
//

- reportOOEProblem: (const char *)title
	format: (const char * ) format, ...;
{
	va_list a; 
	char alert[2048];

	va_start(a, format);
	vsprintf(alert, format, a);
	va_end(a);
	
	NXRunAlertPanel(title, alert, "OK", NULL, NULL);
	
	return self;
}

@end


